/*   port_lookup.c
 *   Copyright 2002-2004 Kirby Kuehl (vacuum@users.sourceforge.net)
 *   This file is part of pixilate
 *   http://winfingerprint.sourceforge.net/pixilate.php
 *
 *   pixilate is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   pixilate is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *   You should have received a copy of the GNU General Public License
 *   along with pixilate; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include "pixilate.h"
/* PIX TCP and UDP literal lookup */

u_short port_lookup(char *literal, struct acl *pacl)
{
    struct servent *se;
    struct protoent *pe;

    if((pe = getprotobynumber(pacl->protocol))==NULL)
    {   /* Should not happen since already checked in protocol_lookup() */
        fprintf(stdout,"PIXILATE PROTOCOL LOOKUP ERROR: %d\n",pacl->protocol);
        fprintf(stdout,"Check your /etc/protocols file.\n");
        return(0);
    }
    
    if((se = getservbyname(literal,pe->p_name)) == NULL)
    {
        /* If getservbyport fails, we are left with no choice but to 
         * return atoi(literal) */
        if((se = getservbyport(atoi(literal),pe->p_name)) == NULL)
        {   
            fprintf(stdout,"PIXILATE PORT LOOKUP ERROR: %s\n",literal);
            fprintf(stdout,"Check your /etc/services file.\n");
            return(atoi(literal)); 
    	}
    }
    return(se->s_port);
}
